(**************************************************)
(* this program demonstrate two other processes   *)
(* the first - drawing Sierpinski line (level 4)  *)
(* the second - drawing Sierpinski line (level 3) *)
(* then (level 2) then (level 1) then write       *)
(* 'Press any Key'                                *)
(* for Sinchronization used TSignal

p   p楤p AA  BB - p pᮢ  
祣    ⮬, p  ᥩ 祣 .  㯮 p ᠬ ᥡ
 ⮫쪮  ⮬,     pp  , ᪠ ⠭
pp VGA
*)
(**************************************************)
{$X+}
uses Graph,Crt,Process,Schedul,Sierpinski;
var
  Gd,Gm: integer;
type
  PDemoProcess = ^TDemoProcess;
  TDemoProcess = object(TProcess)
     X,Y: integer;
     color : Word;
  end;

  PGraphScheduler = ^TGraphScheduler;
  TGraphScheduler = object(TScheduler)
      function Swap(NextProcess: PProcess): PProcess; virtual;
  end;


  TDemoSierpinski = object(TSierpinski)

    procedure LineRel(dx,dy: integer); virtual;
  end;

(**************************************************************)
(* procedure Swap must save Current position and Color Line,  *)
(* and then Restore Current position and Color Line for other *)
(* proces; Processes defined by ActiveProcess and NextProcess *)
(**************************************************************)
function TGraphScheduler.Swap(NextProcess: PProcess): PProcess;
begin
   pushf;
   cli;
      with PDemoProcess(ActiveProcess)^ do begin
        X := GetX;
        Y := GetY;
        Color := GetColor;
      end;
   with PDemoProcess(NextProcess)^ do begin
      MoveTo(X,Y);
      SetColor(Color);
   end;
   Swap := TScheduler.Swap(NextProcess);
   popf;
end;

procedure TDemoSierpinski.LineRel(dx,dy: integer);
begin
  Scheduler^.Lock;
  Graph.LineRel(dx,dy);
  Scheduler^.UnLock;
  wait(1);
end;


procedure SetColor(Color: word);
begin
  Scheduler^.Lock;
  Graph.SetColor(Color);
  Scheduler^.UnLock;
end;


var
  Pa,Pb: PDemoProcess;
  S1,S2: TSignal;
procedure AA; far;
var
  S: TDemoSierpinski;
begin
  S.Init;

  SetColor(14);
  S.Draw(3);

  SetColor(15);
  S.Draw(2);

  SetColor(11);
  S.Draw(1);

  S1.Send;
  S2.Wait;
  S.Done;

  Transfer(CurrentProcess,PB);
end;

procedure bb; far;
var
  S: TDemoSierpinski;
begin
  S.Init;

  SetColor(13);
  S.Draw(4);
  S2.Send;
  S1.Wait;

  S.Done;
  Scheduler^.Lock;
  OutTextXY(1,1,'Press AnyKey');
  Scheduler^.UnLock;

  Scheduler^.Done;
end;


begin
  S1.Init;
  S2.Init;
  PA := New(PDemoProcess, Init(10000));
  PB := New(PDemoProcess, Init(10000));

  PA^.LinkProc(AA);
  PB^.LinkProc(BB);

  Gd := Detect;
  InitGraph(Gd,Gm,'');
  SetTextStyle(1,0,3);

  Scheduler := New(PGraphScheduler, Init(20,10));
   with Scheduler^ do begin

      Insert(PA,1);
      Insert(PB,3);

      Start;
   end;
  readkey;
  CloseGraph;
end.
