{$X+}
unit PasRobot;
interface
uses Process,Objects,Init;
type
  TCos = array [0..90] of word;
const
  MaxLen = 12;
  Cos : TCos =
(256, 256, 256, 256, 255, 255, 255, 254, 254, 253, 252, 251, 250, 249, 248,
247, 246, 245, 243, 242, 241, 239, 237, 236, 234, 232, 230, 228, 226, 224,
222, 219, 217, 215, 212, 210, 207, 204, 202, 199, 196, 193, 190, 187, 184,
181, 178, 175, 171, 168, 165, 161, 158, 154, 150, 147, 143, 139, 136, 132,
128, 124, 120, 116, 112, 108, 104, 100, 96, 92, 88, 83, 79, 75, 71, 66, 62,
58, 53, 49, 44, 40, 36, 31, 27, 22, 18, 13, 9, 4, 0);

  RMax  = 1280* MaxSph;
  LifeCount = 1;
  MaxDamage = LifeCount*(RMax div 8);
  SoldierNo : byte= 0;
  MaxX = 511;
  MaxY = 468;
  MaxSpeed = 100;
  SingleSpeed : word = 255;  (* used for define addX = Vcos() and addY = Vsin() *)
  KK = 3;
  XPos = 528;
  YPos: word = 0;
  dy = 40;
type
  TPoint = record
      X,Y: word;
  end;

  TSpeed = 0..KK*MaxSpeed;
  TDamage = 0..MaxDamage;
  TAngle = 0..719;
  TRange = 0..512;
  TName = string[Maxlen];

  PDragObject = ^TDragObject;
  TDragObject = object(TProcess)
     Locate: TPoint;

{     x,y: word;     }

     addX,addY: integer;
     Owner: PObject;

     Constructor Init(StartPoint: TPoint; a: TAngle;
                      Speed: TSpeed; P: PObject);
     procedure Body; virtual;
     procedure SetParam(a: TAngle;var speed: TSpeed); virtual;
  end;

  PDragPattern = ^TDragPattern;
  TDragPattern = object(TProcess)
     Image: string;

     constructor Init(StartPoint: TPoint; c: char;
                       a: TAngle; Speed: TSpeed);
     destructor Done; virtual;
     function Valid(x,y: longInt): boolean; virtual;
     procedure EraseImage; virtual;
     procedure DrawImage;  virtual;
     procedure ReachLimit; virtual;

     private
     DragObject : PDragObject;
  end;

  PBullet = ^TBullet;
  TBullet = object(TDragPattern)
    LastRange: LongInt;
    Target: TPoint;

    constructor Init(StartPoint: TPoint; a: TAngle; Range: TRange);
    function Valid(x,y: LongInt): boolean; virtual;
    procedure ReachLimit; virtual;
    procedure Ba_BAH(Point: TPoint);
  end;

  PSoldier = ^TSoldier;
  TSoldier = object(TDragPattern)
     Havedamage: TDamage;
     Name : TName;
     DamageShowY : integer;

     constructor Init(X1,Y1: Word; AName: TName);

     procedure Die; virtual;
     procedure ReachLimit; virtual;
     procedure Stop; virtual;
     function Get_X: word;
     function Get_Y: word;
     procedure drive(a:TAngle; Speed: TSpeed); virtual;
     procedure cannon(angle:TAngle; Range: TRange); virtual;
     function Scan(a,resolution:TAngle): TRange; virtual;

{     procedure GetSpeed(var a:TAngle; var Speed: TSpeed); virtual;}
     function Damage: TDamage; virtual;
  end;

var
  BattleField : TCollection;
function ICos(angle: integer): integer;
function ISin(angle: integer): integer;
function MRange(a,b: TPoint): LongInt;

implementation
uses hlev0,Schedul,TrigData,Crt;
function ICos;
begin
  angle := abs(angle) mod 360;
  case angle of
    0..90:     ICos := Cos[angle];
    91..180:   ICos := -cos[180-angle];
    181..270:  ICos := -cos[angle-180];
    271..359:  ICos := cos[360-angle];
  end; {case}
end;

function ISin;
begin
  angle := abs(angle+90) mod 360;
  case angle of
    0..90:     ISin := -cos[angle];
    91..180:   ISin := cos[180-angle];
    181..270:  ISin := cos[angle-180];
    271..359:  ISin := -cos[360-angle];
  end; {case}
end;

function MRange(a,b: TPoint): LongInt; assembler;
asm
  mov ax,a.X
  mov bx,b.x
  mov cx,a.y
  mov dx,b.y
  cmp bx,ax
  jb  @1
  xchg ax,bx
@1:
  cmp dx,cx
  jb  @2
  xchg cx,dx
@2:
  sub  ax,bx
  sub  cx,dx
  cmp  cx,ax
  jb   @3
  xchg ax,cx
@3:
  shr  cx,1
  xor  dx,dx
  add  ax,cx
  adc  dx,0
end;

const
  K = 6;
  K2 = 64;  { 2^k}
type
  TRect = record
     A,B: TPoint;
  end;

const
  BattleArea : TREct = (A : (X:0; Y:0);
                        B : (X:MaxX*128; Y:MaxY*128));
procedure EndGame;
begin
  moveab(0,0);
  Text(PSoldier(BattleField.At(0))^.Name+' is a winer');
  Readkey;
  Scheduler^.Done;
end;


procedure FreeBullet(P: PObject);
begin
   if P <> nil then begin
     Dispose(P ,Done);
     Scheduler^.Slice(RandomTick);
   end;
end;

procedure FreeSoldier(P: PObject);
begin
   if P <> nil then begin
     Dispose(P ,Done);
     if BattleField.Count <= 1 then begin
{         Scheduler^.Delete(BattleField.Items^[0]);
         PSoldier(BattleField.Items^[0])^.HaveDamage := 0;}
         PSoldier(BattleField.Items^[0])^.Drive(45,MaxSpeed);
         Scheduler^.Slice(FullTick);
         EndGame;
     end;
     Scheduler^.Slice(RandomTick);
   end;
end;

     {TDragObject}
constructor TDragObject.Init(StartPoint: TPoint; a: TAngle;
                            Speed: TSpeed;  P: PObject);
begin
  TProcess.Init(1000);
  Locate := StartPoint;
  Owner := P;
  SetParam(a,Speed);
  Scheduler^.Insert(@Self,speed);
end;

procedure TDragObject.Body;
begin
   while true do
      with PDragPattern(Owner)^,Locate do
         if Valid(longInt(x)+addX,longInt(y)+addY) then begin
            cli;
            EraseImage;
            x := x+addX;
            y := y + addY;
            DrawImage;
            Scheduler^.Slice(FullTick);
         end
         else ReachLimit;
end;

procedure TDragObject.SetParam(a: TAngle;var speed: TSpeed);
var
  K : integer;
begin
   if Speed <> 0 then begin
      addX := SingleSpeed*ICos(a) div K2;
      addY := SingleSpeed*ISin(a) div K2;
      case Speed of
         1..MaxSpeed div 4: K := 2;
         MaxSpeed div 4 + 1..MaxSpeed div 2: K := 1;
         else K := 0;
      end;
      Speed := Speed shl K;
      addX := addX shr K;
      addY := addY shr K;
   end
  else begin
         addX := 0;
         addY := 0;
       end;
end;

constructor TDragPattern.Init(StartPoint: TPoint; c: char; a: TAngle; Speed: TSpeed);
begin
  TProcess.Init(1000);
  Image := c;
  DragObject := New(PDragObject, Init(StartPoint,a,Speed,@Self));
  with StartPoint do
  DrawImage;
  Scheduler^.Insert(@Self,20);
end;

destructor TDragPattern.Done;
begin
  TProcess.Done;
end;

function TDragPattern.Valid(x,y: LongInt): boolean;
begin
   with BattleArea do
      Valid := (x >= A.x) and (x <= B.x) and (y >= A.y) and (y <= B.y);
end;

procedure TDragPattern.EraseImage;
begin
   with DragObject^.Locate do
     moveab(x shr 7,MaxY - (y shr 7));
   Text(Image);
end;

procedure TDragPattern.DrawImage;
begin
   with DragObject^.Locate do
     moveab(x shr 7,MaxY - (y shr 7));
   Text(Image);
end;

procedure TDragPattern.ReachLimit;
begin
  Abstract;
end;

{  TBullet }

constructor TBullet.Init(StartPoint: TPoint; a: TAngle; Range: TRange);
procedure DefineTarget(R: TRange);
var
  tmpx,tmpy: LongInt;
  tmpa : integer;
begin

  tmpx := StartPoint.x;
  tmpy := StartPoint.y;
  tmpa := Icos(a);
  asm
    imul  R
    add   tmpx.Word[0],ax
    adc   tmpx.Word[2],dx
  end;
  tmpa := ISin(a);
  asm
    imul  R
    add   tmpy.Word[0],ax
    adc   tmpy.Word[2],dx
  end;

  if not TDragPattern.Valid(tmpx,tmpy) then with BattleArea do begin
      if tmpx < A.x then tmpx := A.x
      else if tmpx > B.x then tmpx := B.x;
      if tmpy < A.y then tmpy := A.y
      else if tmpy > B.y then tmpy := B.y;
  end;

  with Target do begin
    x := tmpx;
    y := tmpy;
  end;

{  LastRange := MRange(Target,StartPoint);}
  LastRange := MaxLongInt;
end;

var
  Nx,Ny: LongInt;
begin
  Scheduler^.Lock;
  TProcess.Init(1000);
  DefineTarget(Range);

  Image := #249; {}
  DragObject := New(PDragObject, Init(StartPoint,a,MaxSpeed*KK,@Self));
  with StartPoint do
  DrawImage;
  Scheduler^.UnLock;
end;


function TBullet.Valid(x,y: LongInt): boolean;
var
  NewRange: LongInt;
  DeltaX,DeltaY: byte;
  Pos : TPoint;
begin
{   Scheduler^.Lock; }
   if TDragPattern.Valid(x,y) then begin
     Pos.x := x;
     Pos.y := y;
     NewRange := MRange(Target,Pos);
     Valid := NewRange < LastRange;
     LastRange := NewRange;
  end
  else  begin
    Target := DragObject^.Locate;
    Valid := False;
  end;
{  Scheduler^.UnLock;}
end;

procedure TBullet.ReachLimit;
begin
  EraseImage;
  Ba_BAH(Target);
  Scheduler^.Delete(DragObject);
  FreeBullet(@Self);
end;

procedure TBullet.Ba_BAH(Point: TPoint);

procedure Damage(El: PSoldier); far;
var
  R: LongInt;

begin
  with El^.DragObject^ do
    R := MRange(Point,Locate);
    if R < RMax then with El^ do begin
       inc(HaveDamage,(RMax - R) div 8);
       Scheduler^.Lock;
       moveab(XPos,DamageShowY);
       if HaveDamage > MaxDamage then begin
           rlenfl(7, 100 ,0);
           dcolor(10);
           Die;
       end
       else asm
              push  7
              les   di,el
              mov   ax,es:[di].HaveDamage
              mov   bx,100
              mul   bx
              mov   bx,MaxDamage
              div   bx
              push  ax
              push  0
              call rlenfl
              push 10
              call dcolor
       end;
       Scheduler^.UnLock;
    end;
end;
begin
   with Target do begin
      Show(x,y);
   end;
   BattleField.ForEach(@Damage);
   with Target do begin
      Show(x,y);
   end;
end;

{TSoldier}
constructor TSoldier.Init(X1,Y1: word; AName: TName);
var
  StartPoint: TPoint;
begin
  Scheduler^.Lock;
  inc(SoldierNo);
  with StartPoint do begin
    X := X1 * 128;
    Y := Y1 * 128;
  end;
  TDragPattern.Init(StartPoint,char(SoldierNo+$2f),0,0);
  BattleField.Insert(@Self);
  Name := AName;
  moveab(XPos,YPos);
  dcolor(14);
  text(Name);
  moveab(633,YPos);
  text(Image);
  DamageShowY := YPos+DY div 2;
  moveab(XPos,DamageShowY);
  rlenfl(15,100,0);

  inc(YPos,DY);
  dcolor(10);
  Scheduler^.UnLock;
end;

function TSoldier.Damage: TDamage;
begin
  Damage := HaveDamage shr 7;
end;

procedure TSoldier.Die;
begin
  EraseImage;
  BattleField.Delete(@Self);

  with Scheduler^ do begin
    cli;
    Delete(DragObject);
    Delete(@Self);
  end;
  FreeSoldier(@Self);
end;

procedure TSoldier.Stop;
var
  Speed : TSpeed;
begin
  Speed := 0;
  DragObject^.SetParam(0,Speed);
end;

function TSoldier.Get_X: word;
begin
  Get_X := DragObject^.Locate.X shr 7;
end;

function TSoldier.Get_Y: word;
begin
  Get_Y := DragObject^.Locate.Y shr 7;
end;

procedure TSoldier.ReachLimit;
begin
  Scheduler^.Slice(FullTick);
  with DragObject^, Locate do
    if Valid(x-addX,y+addY) then addX := - addX
    else addY := - addY;
end;

procedure TSoldier.Drive(a:TAngle; Speed: TSpeed);
begin
  DragObject^.SetParam(a,Speed);
  if Speed <> DragObject^.Prioritet then begin
    cli;
    with  Scheduler^ do
      SumPr := SumPr - DragObject^.Prioritet + Speed;
    DragObject^.Prioritet := Speed;
    Scheduler^.Slice(RandomTick);
  end;
end;

procedure TSoldier.cannon(angle:TAngle; Range: TRange);
var
  Bullet : PBullet;
begin
  Bullet := New(PBullet, Init(DragObject^.Locate,angle,Range div 2));
  Scheduler^.Slice(FullTick);
end;

function TSoldier.Scan(a,resolution:TAngle): TRange;
var
  Range: word;
  a1,a2: integer;
procedure  NormalizeScan(El: PSoldier); far;
var
  curA : TAngle;
  R1 : TRange;
begin
   if El <> @Self then begin
      curA := Arc((El^.DragObject^.Locate.X-DragObject^.Locate.X) div 128,
                  (El^.DragObject^.Locate.Y-DragObject^.Locate.Y) div 128);
      if (curA >= a1) and (curA <= a2) then begin
          R1 := MRange(El^.DragObject^.Locate,DragObject^.Locate);
          if R1 < Range then Range := R1;
      end;
   end;
end;

procedure  NormalizeScan1(El: PSoldier); far;
var
  curA : TAngle;
  R1 : LongInt;
begin
   if El <> @Self then begin
      asm
        les di,El
        les di,es:[di].DragObject
        mov ax,es:[di].TDragObject.Locate.Word[0]
        shr ax,7
        mov bx,es:[di].TDragObject.Locate.Word[2]
        shr bx,7
        mov di,word ptr Self
        les di,ss:[di].6
        les di,es:[di].DragObject
        mov cx,es:[di].TDragObject.Locate.Word[0]
        shr cx,7
        sub ax,cx
        mov cx,es:[di].TDragObject.Locate.Word[2]
        shr cx,7
        sub bx,cx
        push ax
        push bx
        call Arc
        mov  curA,ax
      end;
      if (curA >= a1) and (curA <= a2) then begin
          R1 := MRange(El^.DragObject^.Locate,DragObject^.Locate);
          if R1 < Range then Range := R1;
      end;
   end;
end;

procedure  CarryScan(El: PSoldier); far;
var
  curA : TAngle;
  R1 : TRange;
begin
   if El <> @Self then begin
      curA := Arc(El^.DragObject^.Locate.X-DragObject^.Locate.X,
                  El^.DragObject^.Locate.Y-DragObject^.Locate.Y);
      if (curA >= a1) or (curA <= a2) then begin
          R1 := MRange(El^.DragObject^.Locate,DragObject^.Locate);
          if R1 < Range then Range := R1;
      end;
   end;
end;

begin
{  Scheduler^.Lock;}
  a := a mod 360;
  Range := 65535;
  a1 := a - resolution;
  a2 := a + resolution;
  if a2 > 359 then begin
     a2 := a2 - 360;
     BattleField.ForEach(@CarryScan);
  end
  else BattleField.ForEach(@NormalizeScan1);
  inc(Range);
  Scan := Range div 128;
{  Scheduler^.UnLock;}
end;

begin
  BattleField.Init(20,20);
  Scheduler := New(PScheduler, Init(20,10));
end.
