        .286
        TITLE   SYSTEMY
        LOCALS  @@

        RSP      EQU 4

DATA    SEGMENT WORD PUBLIC
extrn   Test8087, CurrentProcess
DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE,DS:DATA

GetPri:      ; read interrupt controller mask
  xor ah,ah
  in  al,0A1H
  mov ah,al
  in  al,21H
  ret

SetPri:       ; write interrupt controller mask
  out 21H,al
  xchg al,ah
  out 0A1H,al
  ret


PUBLIC Transfer
PFromSeg EQU  28
PFromOfs EQU  26
PToSeg   EQU  24
PToOfs   EQU  22
Transfer:
         pushf
         pusha
         mov  bp,sp
         push ds es 0 0 0FFFFH
Common:
         lds  si,[bp][PToOfs]
         mov  cx,ds            ;Save CurProcessID
         mov  dx,si
         lds  si,[si][RSP]

         les  di,[bp][PFromOfs]
         add  di,RSP
         cld
         mov  ax,sp
         stosw
         mov  ax,ss
         stosw
         ;  ds:si - point to PTo stack
         mov  ax,ds
         mov  ss,ax
         mov  sp,si
         pop  bx ax ax

Simple:
         mov  ax,DATA
         mov  es,ax
         mov  di,offset CurrentProcess
         ;les  di,es:[di]
         mov  ax,dx
         stosW
         mov  ax,cx
         stosW

         pop  es ds
         popa
         popf
         retf 8
	 
PUBLIC IntHandler
FlagsFrom EQU  28
CSFrom    EQU  26
IPFrom    EQU  24
SSeg      EQU  22
CSTo      EQU  20
IPTo      EQU  18
FlagsTo   EQU  16
IntHandler:
         push   ax ax
         pusha
         mov    bp,sp
         push   ds es 0 0 0FFFFh
         mov    ax,[bp][SSeg]
         mov    ds,ax
         mov    si,31*16
         lds    si,[si]
         mov    dx,si
         add    si,RSP
                         ;ds:si point to RSP,RSS
         mov    ax,[bp][FlagsFrom]
         mov    bx,[bp][CSFrom]
         mov    cx,[bp][IPFrom]

         mov    [bp][FlagsTo],ax
         mov    [bp][CSTo],bx
         mov    [bp][IPTo],cx

         ;
         mov  ax,DATA
         mov  es,ax
         mov  di,offset CurrentProcess
         les  di,es:[di]
         add  di,RSP
         mov  ax,sp
         cld
         stosW
         mov  ax,ss
         stosW
         ;
         mov  cx,ds
         lodsw
         mov  bx,ax
         lodsw
         mov  ss,ax
         mov  sp,bx

         ;
         pop  bx
                     ; issue EOI to interrupt controller
         cmp  bx,20H
         jb   skipa0
         cmp  bx,40H
         mov  al,20H
         jae  skip20
         out  20H,al
         jmp  skipa0
skip20:
         cmp  bx,1C0H
         jb   skipa0
         cmp  bx,1E0H
         jae  skipa0
         out  0A0H,al        ;assuming it's an AT
skipa0:
         pop  ax
         pop  si

         xor  di,di
         mov  ds,di
         mov  [bx],si
         mov  [bx+2],ax
         jmp  Simple

PUBLIC IOTransfer
IOTransfer:
         pushf
         cli
         pop      ax   ;flags
         pop      dx   ;ip
         pop      cx   ;cs
         pop      bx   ;int #
         push     cx  ;cs
         push     dx  ;ip
         push     ax
         pusha
         mov      bp,sp
         push     ds es
         xor      ax,ax
         mov      ds,ax
         shl      bx,2
         push     [bx]
         push     [bx+2]
         push     bx

         mov      [bx+2],ss
         mov      word ptr [bx],31*16+4
         jmp      Common

CODE    ENDS
end
