{$G+,D-,S-}
unit Process;
interface
uses Objects;

type
  TProcedure = Procedure;
  PProcedure = ^TProcedure;

const
  NPara = 31;
  SelfProc = nil;

type
  TProcessID = pointer;
  PProcess = ^TProcess;
  TProcess = object(TObject)
                StackSize: word;
                RSP, RSS: word;
                Prioritet,CurPr: integer;
                BodyPtr: pointer;        {to  procedure }

                constructor Init(StackV: word);
                destructor Done; virtual;

                procedure LinkProc(P: TProcedure); virtual;
                procedure Body; virtual;
                procedure EndProcess; virtual;

                private
                SaveStack : word;

                procedure Handler;
             end;


procedure cli;
inline($fa);

procedure sti;
inline($fb);
procedure pushf;
inline($9c);
procedure popf;
inline($9d);

procedure Transfer(PFrom,PTo: Pointer);
procedure IOTransfer(PFrom,PTo: Pointer; IntNo:byte );
procedure Abort(Msg: string);

var
   CurrentProcess: PProcess;

implementation
uses Crt,Memory;
{$L Process}
var
  MainProcess: PProcess;
  MainStack: word;
procedure IntHandler;
external;

procedure IOTransfer(PFrom,PTo: Pointer; IntNo:byte );
external;

procedure Transfer(PFrom,PTo: Pointer);
external;

constructor TProcess.Init(StackV: word);
const
  AddStack = 48;
  (*
      es               2
      di               4         - Self ptr

      X                6
      X                8         imulated  call far(cs:ip)



                                 usialy stack start point:
      X                10        s    imulated
      X                12        o      transfer parameters
      X                14        s
      X                16        o    prepare for retf 8
      seg Handler      18             for continue
      ofs Handler      20             stoped process

      Flags            22
      ax               24        1 by pusha
      cx               26        2
      bx               28        3
      dx               30        4
      si               32        5
      di               34        6
      sp               36        7
      bp               38        8
      ds               40
      es               42
      0                44
      0                46
      0ffffH           48
*)
type
  TIntHandler = record
     adr: pointer;
     pre : byte;
     O: word;
     case Boolean of
       True:(x: byte;AuthorLabel:string[7]);
       False:(S:word);
     end;


var
  PSeg: pointer;
  r: TIntHandler;
begin
  TObject.Init;
  with r do begin
    adr := @Self;
    pre := $9a;
    AuthorLabel := 'Mark Sv';
    S := Seg(IntHandler);
    O := Ofs(IntHandler);
  end;

  StackSize := StackV+AddStack;
    PSeg := MemAllocSeg(StackSize);
    Move(r,PSeg^,SizeOf(r));
    RSS := Seg(PSeg^)-NPara;
    RSP := StackSize+NPara*16 - AddStack;
    asm
      mov  cx,7
      mov  ax,1
      les  di,Self
      push es
 @@0:
      push di
      loop @@0
      push Seg Handler
      push Offset Handler

      pushf
      pusha
      push ds
      push es
      push 0
      push 0
      push 0FFFFH
      les di,dword ptr es:[di].RSP
      cld
      mov cx,24
  @@1:
      pop ax
      stosw
      loop @@1
    end;
    BodyPtr := SelfProc;
    SaveStack := RSS;
end;

destructor TProcess.Done;
begin
  FreeMem(ptr(SaveStack+NPara,0),StackSize);
end;

procedure TProcess.LinkProc(P: TProcedure);
begin
  BodyPtr := @P;
end;

procedure TProcess.Body;
begin
   while true do
     asm
       nop
     end;
end;

procedure TProcess.EndProcess;
begin
  Abort('Process Finished.');
end;


procedure TProcess.Handler;
begin
  if BodyPtr = SelfProc then Body
  else TProcedure(BodyPtr);
  EndProcess;
end;
procedure Abort(Msg: string);
begin
  HighVideo;
  Writeln(Msg);
  LowVideo;
  Writeln('Programm Aborted');
  Halt(0);
end;

begin
   New(MainProcess);
   MainProcess^.StackSize := 0;
   MainProcess^.RSS := SSeg;
   MainStack := SSeg;
   CurrentProcess := MainProcess;
end.
